unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons;

type

  tTypes = (Lat, Lon, City, Country, Region, Look, eNil);
  tFiles  = (Airports, ByAirports, byRegions, byCountry, Regions, RegStateCoICAO, WrkFile);

  PData = ^TData;
   TData = record
   ICAO        : String[8];
   Region      : String[3];
   Hash        : Double;
   HashStr     : String[12];
   City        : String[25];
   Country     : String[25];
   Lat         : Double;
   LatStr      : String[12];
   Lon         : Double;
   LonStr      : String[12];
   RCDLine     : String[95];
   Distance    : Double;
   DistanceStr : String[12];
   end;



  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    btnTest: TBitBtn;
    btnClose: TBitBtn;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    ListBox1: TListBox;
    ListBox2: TListBox;
    ListBox3: TListBox;
    ListBox4: TListBox;
    procedure btnCloseClick(Sender: TObject);
    procedure btnTestClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    Procedure LoadATextFile(Const aMode : tFiles; Const APath : String; aBox : TListBox);




    function Decompose(aRCD : TData ) : TData;
    function CleanRecord (aRcd : TData) : Tdata;



  private

  public

  end;
Const
  Digits = ['0'..'9'];
  MaxDisplay = 10;
  C_ByRegion  = 'E:\Files\Region\Composite.txt';
  C_ByAirport = 'E:\Files\Airports\ByAirport.txt';

var
  Form1: TForm1;
//  UserRCD         : TData;
  DynamicRcd      : TData;
  StaticRcd       : TData;

implementation
 uses strutils, LCLType;
{$R *.lfm}

resourcestring
  sSrcDefHint   = 'Double-click the item to decompose';
  sClickAString = 'Please, double click in a string';
  sfWithFloat = '%d = %s - As float: %f';
  sfNoFloat   = '%d = %s';

{ TForm1 }

 procedure TForm1.FormCreate(Sender: TObject);
 begin
  if FileExists(C_ByAirport) then begin
     LoadATextFile(Airports,C_ByAirport,Listbox2); end;
  Listbox1.Clear;
  if FileExists(C_ByRegion) then begin
     LoadATextFile(Regions,C_ByRegion,Listbox1); end;
 end;


 Procedure TForm1.LoadATextFile(Const aMode : tFiles; Const APath : String; aBox : TListBox);
   var RCD : TData;
    DataFile : TextFile;
    Line     : String = '';
    ICAO     : String = '';
 begin
  if not FileExists(aPath) then begin ShowMessage('File Not found'); exit; end;
   AssignFile(DataFile, aPath);
  try
    Reset(Datafile);
    try
      while not EoF(DataFile) do begin
        ReadLn(DataFile, Line);
        Line := Trim(Line);

        if aMode = Regions then
          begin
           aBox.Items.Add(Line);
        end;

        if aMode = Airports then begin
           ICAO := ExtractWord(1,Line,['[',']']);
           ICAO := Trim(ICAO);
           if ICAO.IsEmpty then begin Continue; end;
           if ICAO = '99'  then begin Continue; end;
           if ICAO.IsEmpty then begin Continue; end;
           Listbox3.Items.Add(ICAO);
           aBox.Items.Add(Line);
        end;

       if aMode = RegStateCoICAO then begin aBox.Items.Add(Line); end;
      end;
     except ShowMessage('Error reading file:'); end;
  finally
    CloseFile(DataFile);
  end;
 end;

 procedure TForm1.btnCloseClick(Sender: TObject);
  begin
    ListBox1.Clear;
    ListBox2.Clear;
    ListBox3.Clear;
    Close;
  end;

 procedure TForm1.btnTestClick(Sender: TObject);
  Var i : Integer = 0;
   RCD : TData;
   IDX : Integer = 0;
   aStr : String;
  begin
   RCD := CleanRecord(RCD);
   for i := 0 to Listbox1.Items.Count -1 do begin
       aStr := Listbox1.Items[i];
       RCD.RCDLine:= aStr;
       Decompose(RCD);
   end;
  end;

  function TForm1.Decompose(aRCD : TData ) : TData;
 //function TForm1.Decompose(Index: Integer; aRCD : TData ) : TData;
  {Decompose "Index"th string from SrcList and add the words to DestList }
 var RCD : TData;
  Count: Integer;
  AWord: String;
  Delims: TSysCharSet;
  AFloat: Extended;
  Test : String;
  RCDString : String[95];
 begin
  RCD := aRCD;
//  Test := ListBox1.Items[Index];
  Delims := ['[',']'];
  { Extract all words }
  RCDString := RCD.RCDLine;
  ListBox4.Clear;
  Count := 0;
    repeat
      Inc(Count);
      AWord := ExtractWord(Count, RCDString, Delims);
      if not AWord .IsEmpty then
        if TryStrToFloat(AWord, AFloat) then
          { If a float, show also the StrToFloat conversion}
          ListBox4.Items.Add(sfNoFloat,[Count, AWord])
         // sfWithFloat = '%d = %s - As float: %f';
        else
         ListBox4.Items.Add(sfNoFloat,[Count, AWord]);
    until AWord.IsEmpty;
    ShowMessageFmt('Found %d words', [Count-1]);
    Result := RCD;
  end;

 function TForm1.CleanRecord (aRcd : TData) : Tdata;
  Var RCD : TData;
  begin
   RCD.ICAO:='';
   RCD.Region:='';
   RCD.Hash:=0;
   RCD.HashStr:='0';
   RCD.City:='';
   RCD.Country:='';
   RCD.Lat:=0;
   RCD.LatStr:='0';
   RCD.Lon:=0;
   RCD.LonStr:='0';
   RCD.RCDLine:='';
   RCD.Distance:=0;
   RCD.DistanceStr:='0';
   Result :=RCD;
  end;

end.

